//+------------------------------------------------------------------+
//|                                                  NonLagMA_v5.mq4 |     D1  
//         
/*+------------------------------------------------------------------+
               , 
       -  (LWMA).
 
          . 

      ( )     ,   .
         FATL,SATL    . 
     FATL. 
 ,     ,       
     :
price = iMA(NULL,0,1,0,1,Price,i+shift),     2   3.

25.09.2006 12:44 igorad 

  ,     - GENRI OZ.

  
-      ( )
-          
-          (    )
-             IP       
- 
 +------------------------------------------------------------------+*/
/*
http://articles.mql4.com/ru/297
solandr ():
      ? 
, solandr,     .    , , , 
 LWMA -        - : 
  N ,       , 
           . 
    (   ),   . 
 Trading Solutions   .  ,    
 LRMA      (    ), 
  ,          
   .  :

               LRMA = 3*LWMA - 2*MA
  : LRMA = 

     ,      
  .       (  
 ).      -    , 
   ,          
""   ( LRMA -      ). 
     .

 04.02.2007 04:22 Mathemat 

                                //   - White -       ,      

*/ 
#property copyright "copywriter-OZ"
#property link      "finansovyj-dozor.narod.ru"
//----
#property indicator_chart_window
//        -       //
//          -    -    
//                   
//#property  indicator_separate_window //   -    !!!

#property indicator_buffers 6
#property indicator_color1 Magenta
//#property indicator_width1 2
#property indicator_color2 DeepSkyBlue
//#property indicator_width2 2 
#property indicator_color3 Yellow
//#property indicator_width3 2

#property indicator_color4 Gold
//#property indicator_width4 2

#property indicator_color5 Aqua
//#property indicator_width5 2

#property indicator_color6 Gold //         !!!!!!!
//#property indicator_width6 2

//---- input parameters

extern string OZ = "SYS-STRANA-OZ";

extern int     Price          = 6;  // Apply to Price(0-Close;1-Open;2-High;3-Low;4-Median price;
                                    // 5-Typical price;6-Weighted Close; 7--Previous Indicator`s -   ???) 
extern int     Length         = 9;  // Period of NonLagMA                     9   13
extern int     Displace       = 0;  // DispLace or Shift                      
extern int     Filter         = 5;  // Static filter in points //             2, 8, 13 ...
extern int     Color          = 1;  // Switch of Color mode (1-color)          
extern int     ColorBarBack   = 0;  // Bar back for color mode                 1   2 ,  0  3 
extern double  Deviation      = 0;  // Up/down deviation    

extern int CountBars = 800;//769; //-    4 (  30   ),       1  ..    
                            //-       3-  .. 500       

extern int     Shift         = 0;  //   1 -  

extern string Zametki1 = ".      . - .....831 - ISBN 5-9614-0031-X";
extern string Zametki2 = " , , CFD,     EURGBP.   ,  ";
extern string Zametki3 = "   -,     (: -30, -D1 ...)";
extern string Zametki4 = "   2- . -  23.30  8.30 -    ";
extern string Zametki5 = "  10 000 -    0.2  -   1:10";
extern string Zametki6 = "     2- ";
extern string Zametki7 = "     -    ";
extern string Zametki8 = ".  -  ...";
extern string Zametki9 = " ...";
extern string Zametki11 = " --   ";
extern string Zametki12 = "          5   ( )";
extern string Zametki13 = "   ( )   ";
extern string Zametki14 = "if((Close[i]-Open[i])/(High[i]-Low[i])>((Close[i-1]-Open[i-1])+(Close[i-2]-Open[i-2]))/((High[i-1]-Low[i-1])+(High[i-2]-Low[i-2]))";
extern string Zametki15 = "if((High[i]>High[i-1] && Low[i]>Low[i-1])-   if((High[i]<High[i-1] && Low[i]<Low[i-1])-";
extern string Zametki16 = "   - ,      1/2   - ";
extern string Zametki17 = "  5,10,20,40,80...    ZO      1,618";
extern string Zametki18 = "      ZO";
extern string Zametki19 = "";
extern string Zametki20 = "  ";
extern string Zametki21 = "     ( )";
extern string Zametki22 = "         ";
extern string Zametki23 = "         (    )";
extern string Zametki24 = "            IP       ";


  
//---- indicator buffers 
double MABuffer[];
double UpBuffer[];
double DnBuffer[];
double trend[];
//----
double alfa[];
int i, Phase, Len, Cycle = 4;
double Coeff, beta, t, Sum, Weight, g;
double pi = 3.1415926535;   
 
double val1[]; 
double val2[]; 


//SIGNAL_BAR   double   init:
 
//----  ,     
#define S 1 //SIGNAL_BAR -     S
//    #define -        SIGNAL_BAR   (1). 

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(8);
   SetIndexStyle(0, DRAW_LINE,1,5);
   SetIndexBuffer(0, MABuffer);
   SetIndexStyle(1, DRAW_LINE,1,2);
   SetIndexBuffer(1, UpBuffer);
   SetIndexStyle(2, DRAW_LINE,1,2);
   SetIndexBuffer(2, DnBuffer);
   
   SetIndexBuffer(3, trend);
   string short_name;
//---- name for DataWindow and indicator subwindow label
   short_name = "ZO-N-L-M(" + Length + ")";
   IndicatorShortName(short_name);
   SetIndexLabel(0, "ZO-N-L-M");
   SetIndexLabel(1, "Up");
   SetIndexLabel(2, "Dn");
//----
   SetIndexShift(0, Displace);
   SetIndexShift(1, Displace);
   SetIndexShift(2, Displace);
//----   
   SetIndexEmptyValue(0, EMPTY_VALUE);
   SetIndexEmptyValue(1, EMPTY_VALUE);
   SetIndexEmptyValue(2, EMPTY_VALUE);
//----   
   //SetIndexDrawBegin(0, Length*Cycle + Length)
   SetIndexDrawBegin(0, Bars - CountBars);//    -    

   //SetIndexDrawBegin(1, Length*Cycle + Length);
   SetIndexDrawBegin(1, Bars - CountBars);//  

   //SetIndexDrawBegin(2, Length*Cycle + Length);
   SetIndexDrawBegin(2, Bars - CountBars);//  

//---- 

     SetIndexStyle(4, DRAW_ARROW,1,4);//  Aqua  
     SetIndexArrow(4, 241);              // 164 - , 170 - 172 - 174 - 178 -4  180 - 182 -5  184-194 - 
     //194-202-   204-  217  218    221     225    228     
     //233 -  , 236 -  241 -  246 -   
     //255-, 258 -     344- ....
     SetIndexBuffer(4, val1);      //    
//     SetIndexDrawBegin(4, Low);//                                                 ???????
     SetIndexLabel(4, "");
     SetIndexShift(4, Shift); 
          
     SetIndexStyle(5, DRAW_ARROW,1,4);//  Yellow          ========      ?????==========
     SetIndexArrow(5, 242);              // 234 -   248 -   
     SetIndexBuffer(5, val2);      //    
//     SetIndexDrawBegin(5, High);//                                                ???????
     SetIndexLabel(5, "");
     SetIndexShift(5, Shift);
 
   Coeff =  3*pi;
   Phase = Length-1;
   Len = Length*Cycle + Phase;  
   ArrayResize(alfa,Len);
   Weight=0;          
   for(i = 0; i < Len - 1; i++)
     {
       if(i <= Phase - 1) 
           t = 1.0*i / (Phase - 1);
       else 
           t = 1.0 + (i - Phase+1)*(2.0*Cycle - 1.0) / (Cycle*Length - 1.0); 
       beta = MathCos(pi*t);
       g = 1.0 / (Coeff*t+1);   
       if(t <= 0.5 ) 
           g = 1;
       alfa[i] = g * beta;
       Weight += alfa[i];
     }
   return(0);
  }
//+------------------------------------------------------------------+
//| NonLagMA_v5                                                      |
//+------------------------------------------------------------------+
int start()
  {
   int    i, shift, counted_bars = IndicatorCounted(), limit;
   double price;      
   if(counted_bars > 0)  
       limit = Bars - counted_bars;
   if(counted_bars < 0)  
       return(0);
   if(counted_bars ==0)  
       limit = Bars - Len - 1; 
   if(counted_bars < 1) 
       for(i = 1; i < Length*Cycle + Length; i++) 
         {
           MABuffer[Bars-i] = 0;    
           UpBuffer[Bars-i] = 0;  
           DnBuffer[Bars-i] = 0;  
         }
   for(shift = limit; shift >= 0; shift--) 
     {	
       Sum = 0;
       for(i = 0; i <= Len - 1; i++)
	        { 
           price = iMA(NULL, 0, 1, 0, 1, Price, i + shift);      
           Sum += alfa[i]*price;
         }  
	      if(Weight > 0) 
	          MABuffer[shift] = (1.0 + Deviation / 100)*Sum / Weight;
       if(Filter > 0)
         {
           if(MathAbs(MABuffer[shift] - MABuffer[shift+1]) < Filter*Point) 
               MABuffer[shift] = MABuffer[shift+1];
         }
       if(Color>0)
         {
           trend[shift] = trend[shift+1];
           if(MABuffer[shift] - MABuffer[shift+1] > Filter*Point) 
               trend[shift] = 1; 
           if(MABuffer[shift+1] - MABuffer[shift] > Filter*Point) 
               trend[shift] = -1; 
           if(trend[shift] > 0)
             {  
               UpBuffer[shift] = MABuffer[shift];
               if(trend[shift+ColorBarBack] < 0) 
                   UpBuffer[shift+ColorBarBack] = MABuffer[shift+ColorBarBack];
               DnBuffer[shift] = EMPTY_VALUE;
             }
           if(trend[shift] < 0) 
             {
               DnBuffer[shift] = MABuffer[shift];
               if(trend[shift+ColorBarBack] > 0) 
                   DnBuffer[shift+ColorBarBack] = MABuffer[shift+ColorBarBack];
               UpBuffer[shift] = EMPTY_VALUE;
             }
         }
     }
     
     
//==========================================================================================================================1
/*                            

   -    ,       , , 
     .     :

     .    ; 
  -    ,   (   ,      ); 
    , ,    -   . , ,    .
      -       . 
   . ==  ??? ==
        ,     . ==  ??? ==
*/
//                           , 

//     start -    return:
     
     //----  ,          
    static int PrevSignal = 0, PrevTime = 0;
 
    //----       0-,     
    //----  .     , .
    if(S >= 0 && Time[0] <= PrevTime ) //     -   - if(SIGNAL_BAR > 0 && Time[0] <= PrevTime )
        return(0);
    //---- ,    
    PrevTime = Time[0];
    

//=========================================================================================================================2
// ,     start,    . 
//      . 
//             .
//   ,     ( ,  SIGNAL_BAR  0).

// :
    //----          (PrevSignal=0)
    if(PrevSignal <= 0)
      {
        //---- ,       :
//        if(MACDBuffer[S] - SignalBuffer[S] > 0 && 
//           SignalBuffer[S+1] - MACDBuffer[S+1] >= 0)
           //SignalBuffer[SIGNAL_BAR] > 0) //                    ZO -            
          if(MABuffer[S] - Close[S] <= 0)
          {
//----  ,     -  =============================================================3
            PrevSignal = 1;                                     // ..      ???
            //----   :
//       {
//       uptrend = true;  //                                                                           
//       }       
//       if(uptrend != old)//   && uptrend == true ) //       OLD   2   
       //{
//        val1[S] =  SignalBuffer[S+1];//ExtMapBuffer51[i];//LowerBuf2[i]-(LowerBuf10[i]-LowerBuf2[i])*2;
          //val1[S] = alfa[S+1];//
          val1[S] = MABuffer[S+1]-(High[i]-Low[i])*0.7;//  (Ask-Bid)*3 //??????
          //val1[S] = trend[S+1];
          //val1[S] = DnBuffer[S+1];
          //val1[S] = UpBuffer[S+1];
          
            Alert("ZO-N-L-M (", Symbol(), ", ", Period(), ", ",AccountEquity(), ", ",AccountLeverage(), ", ",AccountProfit(), ", ",AccountFreeMargin(), ")  -  BUY!-  D1-   Dealers C 6.00  8.30- -0ZO-N-L-M");//
//            Print("sMACD (", Symbol(), ", ", Period(), ")  -  BUY!!!");
//            Comment("sMACD (", Symbol(), ", ", Period(), ")  -  BUY!!!");
//            PlaySound("Alert.wav");

          }
      }


//----      =============================================================================4
    if(PrevSignal >= 0)
      {
//        if(SignalBuffer[S] - MACDBuffer[S] > 0 && 
//           MACDBuffer[S+1] - SignalBuffer[S+1] >= 0)
           //                                ZO -    
           if(MABuffer[S] - Close[S] >= 0)
          {
            PrevSignal = -1;
 //  GlobalVariableSet("OZ-MACD",0);//("goSELL", 0); //     goSELL=0
 //  GlobalVariableSet("OZ-MACD",0);//("goBUY", 0);  //     goBUY =0
            
//        val2[S] =  SignalBuffer[S+1];//ExtMapBuffer51[i];//LowerBuf2[i]-(LowerBuf10[i]-LowerBuf2[i])*2;
          //val2[S] = alfa[S+1];//
          val2[S] = MABuffer[S+1]+(High[i]-Low[i])*0.5;//  (Ask-Bid)*3 //??????
          //val2[S] = trend[S+1];
          //val2[S] = DnBuffer[S+1];
          //val2[S] = UpBuffer[S+1];
          
            Alert("ZO-N-L-M (", Symbol(), ", ", Period(), ", ",AccountEquity(), ", ",AccountLeverage(), ", ",AccountProfit(), ", ",AccountFreeMargin(), ")  -  SELL!-  D1-   Dealers C 6.00  8.30- -0ZO-N-L-M");//ZO-N-L-M 
//            Print("sMACD (", Symbol(), ", ", Period(), ")  -  SELL!!!");
//            Comment("sMACD (", Symbol(), ", ", Period(), ")  -  SELL!!!");
//            PlaySound("Alert.wav");
          }
      }
  
//==============================================================================================================================

     
	  return(0);	
  }
//+------------------------------------------------------------------+